## List rate limits `rate_limits.list(RateLimitListParams**kwargs) -> SyncV4PagePaginationArray[RateLimit]` **get** `/zones/{zone_id}/rate_limits` Fetches the rate limits for a zone. ### Parameters - `zone_id: str` Defines an identifier. - `page: Optional[float]` Defines the page number of paginated results. - `per_page: Optional[float]` Defines the maximum number of results per page. You can only set the value to `1` or to a multiple of 5 such as `5`, `10`, `15`, or `20`. ### Returns - `class RateLimit: …` - `id: Optional[str]` The unique identifier of the rate limit. - `action: Optional[Action]` The action to perform when the threshold of matched traffic within the configured period is exceeded. - `mode: Optional[Literal["simulate", "ban", "challenge", 2 more]]` The action to perform. - `"simulate"` - `"ban"` - `"challenge"` - `"js_challenge"` - `"managed_challenge"` - `response: Optional[ActionResponse]` A custom content type and reponse to return when the threshold is exceeded. The custom response configured in this object will override the custom error for the zone. This object is optional. Notes: If you omit this object, Cloudflare will use the default HTML error page. If "mode" is "challenge", "managed_challenge", or "js_challenge", Cloudflare will use the zone challenge pages and you should not provide the "response" object. - `body: Optional[str]` The response body to return. The value must conform to the configured content type. - `content_type: Optional[str]` The content type of the body. Must be one of the following: `text/plain`, `text/xml`, or `application/json`. - `timeout: Optional[float]` The time in seconds during which Cloudflare will perform the mitigation action. Must be an integer value greater than or equal to the period. Notes: If "mode" is "challenge", "managed_challenge", or "js_challenge", Cloudflare will use the zone's Challenge Passage time and you should not provide this value. - `bypass: Optional[List[Bypass]]` Criteria specifying when the current rate limit should be bypassed. You can specify that the rate limit should not apply to one or more URLs. - `name: Optional[Literal["url"]]` - `"url"` - `value: Optional[str]` The URL to bypass. - `description: Optional[str]` An informative summary of the rule. This value is sanitized and any tags will be removed. - `disabled: Optional[bool]` When true, indicates that the rate limit is currently disabled. - `match: Optional[Match]` Determines which traffic the rate limit counts towards the threshold. - `headers: Optional[List[MatchHeader]]` - `name: Optional[str]` The name of the response header to match. - `op: Optional[Literal["eq", "ne"]]` The operator used when matching: `eq` means "equal" and `ne` means "not equal". - `"eq"` - `"ne"` - `value: Optional[str]` The value of the response header, which must match exactly. - `request: Optional[MatchRequest]` - `methods: Optional[List[Literal["GET", "POST", "PUT", 4 more]]]` The HTTP methods to match. You can specify a subset (for example, `['POST','PUT']`) or all methods (`['_ALL_']`). This field is optional when creating a rate limit. - `"GET"` - `"POST"` - `"PUT"` - `"DELETE"` - `"PATCH"` - `"HEAD"` - `"_ALL_"` - `schemes: Optional[List[str]]` The HTTP schemes to match. You can specify one scheme (`['HTTPS']`), both schemes (`['HTTP','HTTPS']`), or all schemes (`['_ALL_']`). This field is optional. - `url: Optional[str]` The URL pattern to match, composed of a host and a path such as `example.org/path*`. Normalization is applied before the pattern is matched. `*` wildcards are expanded to match applicable traffic. Query strings are not matched. Set the value to `*` to match all traffic to your zone. - `response: Optional[MatchResponse]` - `origin_traffic: Optional[bool]` When true, only the uncached traffic served from your origin servers will count towards rate limiting. In this case, any cached traffic served by Cloudflare will not count towards rate limiting. This field is optional. Notes: This field is deprecated. Instead, use response headers and set "origin_traffic" to "false" to avoid legacy behaviour interacting with the "response_headers" property. - `period: Optional[float]` The time in seconds (an integer value) to count matching traffic. If the count exceeds the configured threshold within this period, Cloudflare will perform the configured action. - `threshold: Optional[float]` The threshold that will trigger the configured mitigation action. Configure this value along with the `period` property to establish a threshold per period. ### Example ```python import os from cloudflare import Cloudflare client = Cloudflare( api_token=os.environ.get("CLOUDFLARE_API_TOKEN"), # This is the default and can be omitted ) page = client.rate_limits.list( zone_id="023e105f4ecef8ad9ca31a8372d0c353", ) page = page.result[0] print(page.id) ``` #### Response ```json { "errors": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "messages": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "result": [ { "id": "372e67954025e0ba6aaa6d586b9e0b59", "action": { "mode": "challenge", "response": { "body": "This request has been rate-limited.", "content_type": "text/xml" }, "timeout": 86400 }, "bypass": [ { "name": "url", "value": "api.example.com/*" } ], "description": "Prevent multiple login failures to mitigate brute force attacks", "disabled": false, "match": { "headers": [ { "name": "Cf-Cache-Status", "op": "ne", "value": "HIT" } ], "request": { "methods": [ "GET", "POST" ], "schemes": [ "HTTP", "HTTPS" ], "url": "*.example.org/path*" }, "response": { "origin_traffic": true } }, "period": 900, "threshold": 60 } ], "success": true, "result_info": { "count": 1, "page": 1, "per_page": 20, "total_count": 2000 } } ```